; Simulador del TMS320C3x v2.1 - Proyecto de Fin de Carrera
; Ingenieria Tecnica de Telecomunicacin
; Rubn Alonso Alejandre - Joaqun Cubillo Arribas

; Ejemplo 3.- Busque el <minimo> de los datos almacenados en
;             una tabla.

;*** CODIGO ***************************************************************************
                .start  "CODIGO", 0x809802      ;Comienzo de la seccion de programa
                .sect   "CODIGO"
                .entry  PRACT22                 ;Punto de entrada

PRACT22         LDP     @DATOS                  ;Inicializa el registro DP
                LDI     @stack, SP              ;Inicializa el puntero de pila

                LDI     @pvtabla, AR0           ;AR0 apunta a la tabla 1 (origen)
                LDI     *AR0, R0                ;Carga en R0 lo apuntado por AR0
                LDI     N-2, RC                 ;Numero de iteraciones
                RPTB    FINBUCLE                ;Repite hasta FINBUCLE N-1 veces
                LDI     *++AR0(1), R1           ;Carga en R1 el valor apuntado por AR0+1
                CMPI    R0,R1                   ;Compara R0 y R1
FINBUCLE        LDILT   R1,R0                   ;Si R1 es menor que R0, carga R1 en R0
                STI     R0, @minimo             ;Carga el valor R0 en la direccion minimo



;*** DATOS **************************************************************************
                .start "DATOS", 0x809C00        ;Comienzo de la seccion de datos
                .sect  "DATOS",
                .word  3,4,5,6,5,1,-5,8,9,10    ;Tabla de datos de entrada
N               .set   10                       ;Tamao de la tabla
minimo          .space 1                        ;Espacio para el resultado
pvtabla         .word DATOS                     ;Puntero a la tabla de datos

; Espacio de memoria para la pila
stack           .word $+1                       ;Comienzo de la pila
                .space 256                      ;Reserva 256 posiciones
                .end